
!Importance sampling scheme for the 2D Ising model
! by D.Jost 08/09/09

program mainising

implicit none

include 'global.var' !include global variables

real*8,allocatable		:: SpMtx(:,:) !curent spin matrix
real*8,allocatable		:: N0(:,:) !histograms of visits
real*8		::M !current magnetization
real*8		::NNC !current nearest-neighbour coupling

real*8		::tmm,randomnumber !other local variables
integer		::time,i,j !other local variables

!initialize random number generator
call random_seed()
call initializerandomnumbergenerator(tmm)

!open the input file
open(10,file='input.dat')
read(10,*) P !size of the spin matrix
read(10,*) NumberFlip !number of spin flips
read(10,*) T0 !current temperature
read(10,*) TempMin !minimal scanned temperature
read(10,*) TempMax !maximal scanned temperature
read(10,*) dTemp !temperature interval
close(10)

N=P*P

!initialize the histogram N0
allocate(N0(N+1,N+1)) 
N0=0d0

!generate a random configuration and compute M and NNC
allocate(SpMtx(P,P))
call randomconfig(SpMtx,M,NNC)

do i=1,NumberFlip
	call metropolis(SpMtx,M,NNC,N0)
end do

!compute the current rmms magnetization
call Mbar(N0)

!save the normalized histogram
open(11,file='NormHist.out')
do i=1,N+1
	write(11,*) (N0(i,j)/real(NumberFlip),j=1,N+1)
end do
close(11)
!compute the density of state and the rms magnetization from TempMin to TempMax

call rmsm2(N0)

end program mainising