
!Simple sampling for 3D SAW
! by D.Jost 08/09/09

program mainsaw

implicit none

include 'global.var' !include global variables

real*8,allocatable		::Z(:) !partition function
real*8,allocatable		::Re2(:) !average end-to-end squared distance
real*8		::Rrms !end-to-end root mean squared distance
real*8		::lgNsaw !logarithm of Nsaw

real*8		::tmm,randomnumber !other local variables
integer		::time,i !other local variables

!initialize random number generator
call random_seed()
call initializerandomnumbergenerator(tmm)

!open the input file
open(10,file='input.dat')
read(10,*) NchainMax !maximum growing size
read(10,*) NumberConfig !number of try
close(10)

!compute the properties of the hash table
call hashtable()

!initialize variables
allocate(Z(NchainMax))
Z=0d0

allocate(Re2(NchainMax))
Re2=0d0

do i=1,NumberConfig
	!generate a conformation with the ROsenbluth scheme 
	call rosenbluth(Z,Re2)
end do

!save log(Nsaw) and Rrms
open(11,file='data.out')
do i=1,NchainMax
	lgNsaw=dlog(Z(i)/real(NumberConfig))
	Rrms=dsqrt(Re2(i)/Z(i))
	write(11,*) i,lgNsaw,Rrms
end do
close(11)

end program mainsaw